#########################
#
# Ports CROSS COMPILING
#
#########################
#
# Variables:
#
# X_STAGING_ROOT =	Defaults to ${OBJ_DIR}/${TARGET}.${TARGET_ARCH}
#

X_STAGING_ROOT=${OBJ_DIR}/${TARGET}.${TARGET_ARCH}/rootfs

#TARGET_ARCH!=mips
#ARCH!=  ${UNAME} -p

#_TARGET_DEFS = \
#	TARGET_VENDOR=${TARGET_VENDOR} \
#	TARGET_DEVICE=${TARGET_DEVICE} \
#	FREEBSD_SRC_TREE=${FREEBSD_SRC_TREE} \
#	TARGET_PROFILES="${TARGET_PROFILES}"

CFLAGS="-I${X_STAGING_ROOT}/lib -I${X_STAGING_ROOT}/include -std=c99"

_TARGET_CROSS_DEFS = \
	CHROOTED=no \
	DESTDIR=${X_STAGING_ROOT} \
	LOCALBASE=${X_STAGING_ROOT} \
	CFLAGS="-I${X_STAGING_ROOT}/lib -I${X_STAGING_ROOT}/include -std=c99" \
	CXXFLAGS="-I${X_STAGING_ROOT}/include -I${X_STAGING_ROOT}/include/json" \
	NO_PKG_REGISTER=yes \
	INSTALL_AS_USER=2

PATH=/usr/mips-freebsd/usr/bin:${PATH}
PKG_CONFIG_PATH=${X_STAGING_ROOT}/libdata/pkgconfig/
PKG_DBDIR=${X_STAGING_ROOT}/libdata/var/db/pkg
NO_INSTALL_MANPAGES=yes
WITHOUT_CHECK=yes
NOPORTDOCS=yes
NOPORTEXAMPLES=yes
ac_cv_func_malloc_0_nonnull=yes
ac_cv_func_realloc_0_nonnull=yes
AUTOTOOLS_LOCALBASE=/usr/local
LIBTOOL=/usr/local/bin/libtool
CONFIGURE_HOST=mips-freebsd
LD_LIBRARY_PATH+=${X_STAGING_ROOT}/lib
LD_FLAGS=${X_STAGING_ROOT}/lib

#######
#
# Custom definition variables per-port (WORKAROUND: as to not break/fix /usr/ports/*/*/Makefile's yet!)
#
#######

.for port in ${PKGORIGIN}
.if make(devel/pcre)
_TARGET_CROSS_DEFS = ${TARGET_CROSS_DEFS} \
        CC_FOR_BUILD=/usr/bin/cc
.endif
.endfor

#.for port in ${BUILD_DEPENDS_LIST}
#	@echo "Start ${port} port building..."
#	mkdir -p ${X_STAGING_ROOT}/libdata/var/db/pkg
#	cd ${X_STAGING_ROOT} ;${MAKE} PORT_BUILD_DEPEND_CROSS=${port} port-build-depend-cross
#.endfor
#	@echo "----> Ports dependencies build done ..."


# Cross-compilation of dependency, build dependency must be built with host env
# LIB and RUN dependency should be builded with cross environment
# Else (FETCH, EXTRACT, PATCH, BUILD dependency) with host env

port-build-depend-cross:
.for port in ${PORT_BUILD_DEPEND_CROSS}
	@echo "--------> Start ${port} port building ..."
	@echo "------------> Test FETCH EXTRACT PATCH BUILD dependency for ${dir}..."
	_DEPENDS=$$(cd ${dir} ; ${MAKE} -VFETCH_DEPENDS -VEXTRACT_DEPENDS -VPATCH_DEPENDS -VBUILD_DEPENDS) ; \
	if [ "x$${_DEPENDS}" != "x" ] ; then \
		echo "$${_DEPENDS}" ; \
		${MAKE} -f /usr/ports/Mk/bsd.port.mk BUILD_DEPENDS="$${_DEPENDS}" depends ; \
	fi
	@echo "------------> Test LIB dependency for ${dir}..."
	@_DEPENDS=$$(cd ${dir} ; ${MAKE} -VLIB_DEPENDS) ; \
	echo "LIB_DEPENDS=$${_DEPENDS}" ; \
	for _DEP in $${_DEPENDS} ; do \
		_DEPTEST=$${_DEP%%:*} ; \
		echo "Test if $${_DEPTEST} present" ; \
		LIBNAME=$${_DEPTEST%.*} ; \
		LIBVER=$${_DEPTEST#*.} ; \
		if [ "$${LIBNAME}" = "$${LIBVER}" ] ; then LIBVER="" ; else LIBVER=".$${LIBVER}" ; fi ; \
		SONAME=lib$${LIBNAME}.so$${LIBVER} ; \
		echo Search for $${SONAME} ; \
		MATCHED_LIBS=$$(find ${X_STAGING_ROOT}/lib ${X_STAGING_ROOT}/usr/lib -name $${SONAME}) ; \
		_DEPPATH=$${_DEP#*:} ; \
		if [ -z $${MATCHED_LIBS} ] ; then \
			cd ${ZROUTER_ROOT} ; ${MAKE} ${_TARGET_DEFS} PORT_BUILD_DEPEND_CROSS=$${_DEPPATH} port-build-depend-cross ; \
		fi ; \
	done
	@echo "------------> Test RUN dependency for ${dir}..."
	@_DEPENDS=$$(cd ${dir} ; ${MAKE} -VRUN_DEPENDS) ; \
	echo "RUN_DEPENDS=$${_DEPENDS}" ; \
	for _DEP in $${_DEPENDS} ; do \
		_DEPTEST=$${_DEP%%:*} ; \
		echo "$${_DEPTEST} is pkg-config?" ; \
		if [ "$${_DEPTEST}" = "pkg-config" ] ; then  continue ; fi ; \
		echo "Test if $${_DEPTEST} present" ; \
		_DEPPATH=$${_DEP#*:} ; \
		cd ${ZROUTER_ROOT} ; ${MAKE} ${_TARGET_DEFS} PORT_BUILD_DEPEND_CROSS=$${_DEPPATH} port-build-depend-cross ; \
	done
	@echo "------------> Build ${dir}..."
	@cd ${dir} ; ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} generate-plist
	@PORT_PLIST=$$( cd ${dir} ; ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VTMPPLIST ) ; \
	    PORT_STATUS=$$( ${ZROUTER_ROOT}/tools/checkdep.pl libs $${PORT_PLIST} ${WORLDDESTDIR} ) ; \
	    if [ $${PORT_STATUS} -lt 50 ] ; then \
		    echo "$${PORT_STATUS}% of files matched, do install" ; \
		    rm -f ${ZROUTER_OBJ}/ports/${dir}/.install* ; \
		    echo cd ${dir} ; echo ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} install; \
		    cd ${dir} ; PATH=${FREEBSD_BUILD_ENV_PATH} ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} install || \
			    ( ${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} clean && \
			    echo ${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} configure && \
			    ${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} configure && \
			    mv `${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VPATCH_COOKIE` `${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VPATCH_COOKIE` && \
			    mv `${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VEXTRACT_COOKIE` `${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VEXTRACT_COOKIE` && \
			    mv `${MAKE} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VCONFIGURE_COOKIE` `${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} -VCONFIGURE_COOKIE` && \
			    echo ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} all && \
			    ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} all && \
			    echo ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} install && \
			    ${MAKE} ${_TARGET_CROSS_DEFS} WRKDIR=${ZROUTER_OBJ}/ports/${dir} install ) ; \
	    fi
.endfor
	@echo "--------> Done building ${dir} port ..."


# Host tools required for extract, patch, configure, build etc.
# All dependency should be built and installed with host environment
# so now we don`t care about dependency type.

port-build-depend-host:
	@echo "Start ${PORTNAME} port building..."
.for port in ${PORT_BUILD_DEPEND_HOST}
	@echo "---------> build/install/clean for port ${port} as dependency with host environment"
	cd ${dir} ; ${MAKE} install clean
	@echo "---------> port ${dir} done (dependency)"
.endfor
